<?php
/*
    Desarrollador: Ing. Jean Jairo Benitez Meza
    Ultima Modificación: 11/04/2023
    Módulo: Gestión de Adquisiciones
*/
namespace App\Http\Controllers;

use App\Http\Controllers\Controller;
use App\Http\Controllers\ResponseController;
use App\Http\Controllers\EncryptionController;
use Illuminate\Http\Request;
use Illuminate\Support\Carbon;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;

class DispatchController extends Controller {

    private $responseController;
    private $encController;

    public function __construct() {
        $this->responseController = new ResponseController();
        $this->encController = new EncryptionController();
    }

    public function getDispatch($line) {
        try {
            $arrDispatch = DB::table('S002V01TDESP')
                ->where("DESP_NULI", "=", $line)
                // ->where("DESP_ESTA", "=", "Activo")
                ->get([
                    'DESP_NUDE', // Número de despacho
                    'DESP_NOMB', // Nombre del despacho
                    'DESP_CALL', // Calle
                    'DESP_NUEX', // Número exterior
                    'DESP_NUIN', // Número interior
                    'DESP_COPO', // Código postal
                    'DESP_COLO', // Colonia
                    'DESP_MUNI', // Municipio
                    'DESP_ENTI', // Entidad
                    'DESP_PAIS', // Pais
                    'DESP_ESTA', // Estado
                    'DESP_USRE', // Usuario Registra
                    'DESP_FERE', // Fecha Registra
                    'DESP_USMO', // Usuario Modifica
                    'DESP_FEMO', // Fecha Modifica
                ]);
        } catch(\Exception $e){
            return $this->responseController->makeResponse(true, "ERR_DISPATCH_GET000: No se pudo realizar la consulta a la base.", [], 500);
        }

        return $this->responseController->makeResponse(false, "ÉXITO: Consulta Exitosa", $arrDispatch);
    }

    public function getDispatchActive($line) {
        try {
            $arrDispatch = DB::table('S002V01TDESP')
                ->where("DESP_NULI", "=", $line)
                ->get([
                    'DESP_NUDE', // Número de despacho
                    'DESP_NOMB', // Nombre del despacho
                    // 'DESP_CALL', // Calle
                    // 'DESP_NUEX', // Número exterior
                    // 'DESP_NUIN', // Número interior
                    // 'DESP_COPO', // Código postal
                    // 'DESP_COLO', // Colonia
                    // 'DESP_MUNI', // Municipio
                    // 'DESP_ENTI', // Entidad
                    // 'DESP_PAIS', // Pais
                    // 'DESP_USRE', // Usuario Registra
                    // 'DESP_FERE', // Fecha Registra
                    // 'DESP_USMO', // Usuario Modifica
                    // 'DESP_FEMO', // Fecha Modifica
                ]);
        } catch(\Exception $e){
            return $this->responseController->makeResponse(true, "ERR_DISPATCH_GET000: No se pudo realizar la consulta a la base.", [], 500);
        }

        return $this->responseController->makeResponse(false, "ÉXITO: Consulta Exitosa", $arrDispatch);
    }

    public function registerDispatch(Request $request) {

        $validator = Validator::make($request->all(), [
            'DESPACHO' => 'required|string',
            'CALLE' => 'required|string',
            'NUMERO_EXTERIOR' => 'required|string',
            'NUMERO_INTERIOR' => '',
            'CODIGO_POSTAL' => 'required|string',
            'COLONIA' => 'required|string',
            'MUNICIPIO' => 'required|string',
            'ENTIDAD' => 'required|string',
            'PAIS' => 'required|string',
            'USUARIO' => 'required|string',
            'NUMERO_LINEA' => 'required|string',
        ]);

        if ($validator->fails()) {
            return $this->responseController->makeResponse(
                true,
                "ERR_DISPATCH_REG000: Se encontraron uno o más errores.",
                $this->responseController->makeErrors($validator->errors()->messages()),
                401
            );
        }

        DB::beginTransaction();

        $requestData = $request->all();

        try {
            $user = $this->encController->decrypt($requestData['USUARIO']);
        } catch (\Throwable $th) {
            DB::rollBack();
            return $this->responseController->makeResponse(true, "ERR_DISPATCH_REG001: Ocurrió un error al obtener el contenido.", [], 500);
        }

        $arrInsert = [
            'DESP_NOMB' => $requestData['DESPACHO'],
            'DESP_CALL' => $requestData['CALLE'],
            'DESP_NUEX' => $requestData['NUMERO_EXTERIOR'],
            'DESP_NUIN' => $requestData['NUMERO_INTERIOR'] === '' ? null : $requestData['NUMERO_INTERIOR'],
            'DESP_COPO' => $requestData['CODIGO_POSTAL'],
            'DESP_COLO' => $requestData['COLONIA'],
            'DESP_MUNI' => $requestData['MUNICIPIO'],
            'DESP_ENTI' => $requestData['ENTIDAD'],
            'DESP_PAIS' => $requestData['PAIS'],
            'DESP_NULI' => $requestData['NUMERO_LINEA'],
            'DESP_USRE' => $user,
            'DESP_FERE' => Carbon::now()->timezone('America/Mazatlan')->toDateTimeString(),
            'DESP_FEAR' => DB::raw('CURRENT_TIMESTAMP'),
        ];

        try {
            $responseRequest = DB::table('S002V01TDESP')->insert($arrInsert);
        } catch (\Throwable $th) {
            DB::rollBack();
            return $this->responseController->makeResponse(true, "ERR_DISPATCH_REG002: Ocurrió un error al momento de insertar los datos en la base de datos.", $th->getMessage(), 500);
        }

        if ( !$responseRequest ) {
            DB::rollBack();
            return $this->responseController->makeResponse(true, "ERR_DISPATCH_REG003: Ocurrió un error al insertar el despacho", [], 500);
        }

        DB::commit();
        return $this->responseController->makeResponse(false, "ÉXITO: Registro Exitoso");
    }

    public function updateDispatch(Request $request) {

        $validator = Validator::make($request->all(), [
            'NUMERO_DESPACHO' => 'required|string',
            'DESPACHO' => 'required|string',
            'CALLE' => 'required|string',
            'NUMERO_EXTERIOR' => 'required|string',
            'NUMERO_INTERIOR' => '',
            'CODIGO_POSTAL' => 'required|string',
            'COLONIA' => 'required|string',
            'MUNICIPIO' => 'required|string',
            'ENTIDAD' => 'required|string',
            'PAIS' => 'required|string',
            'USUARIO' => 'required|string',
            'NUMERO_LINEA' => 'required|string',
        ]);

        if ($validator->fails()) {
            return $this->responseController->makeResponse(
                true,
                "ERR_DISPATCH_UPD000: Se encontraron uno o más errores.",
                $this->responseController->makeErrors($validator->errors()->messages()),
                401
            );
        }

        DB::beginTransaction();

        $requestData = $request->all();

        try {
            $user = $this->encController->decrypt($requestData['USUARIO']);
        } catch (\Throwable $th) {
            DB::rollBack();
            return $this->responseController->makeResponse(true, "ERR_DISPATCH_UPD001: Ocurrió un error al obtener el contenido.", [], 500);
        }

        $arrUpdate = [
            'DESP_NOMB' => $requestData['DESPACHO'],
            'DESP_CALL' => $requestData['CALLE'],
            'DESP_NUEX' => $requestData['NUMERO_EXTERIOR'],
            'DESP_NUIN' => $requestData['NUMERO_INTERIOR'] === '' ? null : $requestData['NUMERO_INTERIOR'],
            'DESP_COPO' => $requestData['CODIGO_POSTAL'],
            'DESP_COLO' => $requestData['COLONIA'],
            'DESP_MUNI' => $requestData['MUNICIPIO'],
            'DESP_ENTI' => $requestData['ENTIDAD'],
            'DESP_PAIS' => $requestData['PAIS'],
            'DESP_USMO' => $user,
            'DESP_FEMO' => Carbon::now()->timezone('America/Mazatlan')->toDateTimeString(),
            'DESP_FEAR' => DB::raw('CURRENT_TIMESTAMP'),
        ];

        try {
            $responseRequest = DB::table('S002V01TDESP')
                ->where('DESP_NUDE', '=', $requestData['NUMERO_DESPACHO'],)
                ->where('DESP_NULI', '=', $requestData['NUMERO_LINEA'])
                ->update($arrUpdate);
        } catch (\Throwable $th) {
            DB::rollBack();
            return $this->responseController->makeResponse(true, "ERR_DISPATCH_UPD002: Ocurrió un error al momento de modificar los datos en la base de datos.", $th->getMessage(), 500);
        }

        if ( !$responseRequest ) {
            DB::rollBack();
            return $this->responseController->makeResponse(true, "ERR_DISPATCH_UPD003: Ocurrió un error al modificar el despacho", [], 500);
        }

        DB::commit();
        return $this->responseController->makeResponse(false, "ÉXITO: Modificación Exitoso");
    }

    public function deleteDispatch(Request $request) {
        $validator = Validator::make($request->all(), [
            'NUMERO_DESPACHO' => 'required|string',
            'USUARIO' => 'required|string',
            'NUMERO_LINEA' => 'required|string',
        ]);

        if ($validator->fails()) {
            return $this->responseController->makeResponse(
                true,
                "ERR_DISPATCH_DEL000: Se encontraron uno o más errores.",
                $this->responseController->makeErrors($validator->errors()->messages()),
                401
            );
        }

        DB::beginTransaction();

        $requestData = $request->all();

        try {
            $user = $this->encController->decrypt($requestData['USUARIO']);
        } catch (\Throwable $th) {
            DB::rollBack();
            return $this->responseController->makeResponse(true, "ERR_DISPATCH_DEL001: Ocurrió un error al obtener el contenido.", [], 500);
        }

        $arrDelete = [
            'DESP_ESTA' => 'Eliminado',
            'DESP_USMO' => $user,
            'DESP_FEMO' => Carbon::now()->timezone('America/Mazatlan')->toDateTimeString(),
            'DESP_FEAR' => DB::raw('CURRENT_TIMESTAMP'),
        ];

        try {
            $responseRequest = DB::table('S002V01TDESP')
                ->where('DESP_NUDE', '=', $requestData['NUMERO_DESPACHO'],)
                ->where('DESP_NULI', '=', $requestData['NUMERO_LINEA'])
                ->update($arrDelete);
        } catch (\Throwable $th) {
            DB::rollBack();
            return $this->responseController->makeResponse(true, "ERR_DISPATCH_DEL002: Ocurrió un error al momento de eliminar los datos en la base de datos.", $th->getMessage(), 500);
        }

        if ( !$responseRequest ) {
            DB::rollBack();
            return $this->responseController->makeResponse(true, "ERR_DISPATCH_DEL003: Ocurrió un error al eliminar el despacho", [], 500);
        }

        DB::commit();
        return $this->responseController->makeResponse(false, "ÉXITO: Eliminación Exitosa");
    }
}
